local util = require("util")
local silo_script = require("silo-script")

local created_items = function()
  return
  {
	["infinity-chest"] = 10,
	["infinity-pipe"] = 10
  }
end

local respawn_items = function()
  return
  {
    
  }
end

for k,v in pairs(silo_script.get_events()) do
  script.on_event(k, v)
end

script.on_event(defines.events.on_player_created, function(event)
  local player = game.players[event.player_index]
  util.insert_safe(player, global.created_items)
  player.cheat_mode=true
  player.surface.always_day=true
  player.character_crafting_speed_modifier=100
  player.character_running_speed_modifier=2
  player.character_build_distance_bonus=500
  player.character_reach_distance_bonus=500
  player.character_item_drop_distance_bonus=500
  player.character_resource_reach_distance_bonus=500
  player.character_item_pickup_distance_bonus=10
  player.character_logistic_slot_count_bonus=30
  player.character_trash_slot_count_bonus=20
  player.character_health_bonus=100000
  player.character_inventory_slots_bonus=200

  player.force.research_all_technologies()
  player.game_view_settings.show_rail_block_visualisation = true
 
	player.insert{name="power-armor-mk2", count = 1}
	local p_armor = player.get_inventory(5)[1].grid
	p_armor.put({name = "fusion-reactor-equipment"})
	p_armor.put({name = "fusion-reactor-equipment"})
	p_armor.put({name = "fusion-reactor-equipment"})
	p_armor.put({name = "fusion-reactor-equipment"})
	p_armor.put({name = "personal-roboport-mk2-equipment"})
	p_armor.put({name = "personal-roboport-mk2-equipment"})
	p_armor.put({name = "personal-roboport-mk2-equipment"})
	p_armor.put({name = "personal-roboport-mk2-equipment"})
	p_armor.put({name = "personal-roboport-mk2-equipment"})
	p_armor.put({name = "battery-mk2-equipment"})
	p_armor.put({name = "battery-mk2-equipment"})
	p_armor.put({name = "battery-mk2-equipment"})
	p_armor.put({name = "battery-mk2-equipment"})
	p_armor.put({name = "battery-mk2-equipment"})
	p_armor.put({name = "battery-mk2-equipment"})
	player.insert{name="construction-robot", count = 200}
	player.force.recipes["electric-energy-interface"].enabled=true






-- for name, recipe in pairs(player.force.recipes) do
--	recipe.enabled = true
-- end
  
  
  
  local r = global.chart_distance or 200
  player.force.chart(player.surface, {{player.position.x - r, player.position.y - r}, {player.position.x + r, player.position.y + r}})

  if not global.skip_intro then
    if game.is_multiplayer() then
      player.print({"msg-intro"})
    else
      game.show_message_dialog{text = {"msg-intro"}}
    end
  end

  silo_script.on_event(event)
end)

script.on_event(defines.events.on_player_respawned, function(event)
  local player = game.players[event.player_index]
  player.cheat_mode=true
  player.surface.always_day=true 
  
  
  util.insert_safe(player, global.respawn_items)
  silo_script.on_event(event)
end)

script.on_configuration_changed(function(event)
  global.created_items = global.created_items or created_items()
  global.respawn_items = global.respawn_items or respawn_items()
  silo_script.on_configuration_changed(event)
end)

script.on_load(function()
  silo_script.on_load()
end)

script.on_init(function()
  global.created_items = created_items()
  global.respawn_items = respawn_items()
  silo_script.on_init()
end)

silo_script.add_remote_interface()
silo_script.add_commands()

remote.add_interface("freeplay",
{
  get_created_items = function()
    return global.created_items
  end,
  set_created_items = function(map)
    global.created_items = map
  end,
  get_respawn_items = function()
    return global.respawn_items
  end,
  set_respawn_items = function(map)
    global.respawn_items = map
  end,
  set_skip_intro = function(bool)
    global.skip_intro = bool
  end,
  set_chart_distance = function(value)
    global.chart_distance = tonumber(value)
  end
})
